#include "windows.h"
#include "storm.h"

const DWORD MAX_PRIORITY_FILE_SIZE = 64;
const char PRIORITY_FILE_PATH[] = "(priority)";

HANDLE archive = 0;

DWORD GetPriority(const char* mpq_path) {
	DWORD result = 0;

	HANDLE temp;
	if (SFileOpenArchive(mpq_path, 0, 0, &temp)) {
		HANDLE file;
		if (SFileOpenFile(temp, PRIORITY_FILE_PATH, 0, &file)) {
			DWORD hi_size;
			DWORD size = SFileGetFileSize(file, &hi_size);
			if (hi_size == 0 && size <= MAX_PRIORITY_FILE_SIZE) {
				BYTE buffer[MAX_PRIORITY_FILE_SIZE + 1];
				if (SFileReadFile(file, buffer, size, NULL, NULL)) {
					buffer[size] = '\0';
					result = SStrToInt(buffer);
				}
			}
			SFileCloseFile(file);
		}
		SFileCloseArchive(temp);
	}

	return result;
}

BOOL APIENTRY DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved) {
	switch (fdwReason) {
		case DLL_PROCESS_ATTACH:
			DisableThreadLibraryCalls(hinstDLL);
			char path[MAX_PATH];
			GetModuleFileNameA(hinstDLL, path, sizeof(path));
			if (!SFileOpenArchive(path, GetPriority(path), 0, &archive)) {
				return FALSE;
			}
			break;
		case DLL_PROCESS_DETACH:
			if (archive) {
				SFileCloseArchive(archive);
			}
			break;
	}
	return TRUE;
}
