import sys
import os

MPQ_HEADER_ALIGN = 512


class From:
	Beggining = 0
	Current = 1
	End = 2


def get_padding(position, align):
	return align - (position % align)


def merge(dll, mpq, out):
	with open(dll, 'rb') as a, open(mpq, 'rb') as b, open(out, 'wb') as o:
		o.write(a.read())
		padding = get_padding(o.tell(), MPQ_HEADER_ALIGN)
		o.seek(padding, From.Current)
		o.write(b.read())
		

if __name__ == '__main__':
	from argparse import ArgumentParser

	parser = ArgumentParser(
			description='Merges a DLL and an MPQ file into a mix-archive.'
		)

	parser.add_argument('dll_path', help='path to the DLL file')
	parser.add_argument('mpq_path', help='path to the MPQ-archive')
	parser.add_argument('mix_path', help='path where the resulting mix-archive will be written')

	args = parser.parse_args()

	merge(args.dll_path, args.mpq_path, args.mix_path)


	






















